/* pl-general.c generated by valac 0.10.0, the Vala compiler
 * generated from pl-general.vala, do not modify */

/* pl-general.vala
 *
 * Copyright (C) 2010  Jörn Magens
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jörn Magens <shuerhaaken@googlemail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>


#define PL_TYPE_LIST_TYPE (pl_list_type_get_type ())

#define PL_TYPE_RESULT (pl_result_get_type ())

#define PL_TYPE_TARGET_TYPE (pl_target_type_get_type ())

#define PL_TYPE_CONTENT_TYPE (pl_content_type_get_type ())
#define PL_CONTENT_TYPE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PL_TYPE_CONTENT_TYPE, PlContentType))
#define PL_CONTENT_TYPE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PL_TYPE_CONTENT_TYPE, PlContentTypeClass))
#define PL_IS_CONTENT_TYPE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PL_TYPE_CONTENT_TYPE))
#define PL_IS_CONTENT_TYPE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PL_TYPE_CONTENT_TYPE))
#define PL_CONTENT_TYPE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PL_TYPE_CONTENT_TYPE, PlContentTypeClass))

typedef struct _PlContentType PlContentType;
typedef struct _PlContentTypeClass PlContentTypeClass;
typedef struct _PlContentTypePrivate PlContentTypePrivate;
typedef struct _PlParamSpecContentType PlParamSpecContentType;
#define _g_free0(var) (var = (g_free (var), NULL))

typedef enum  {
	PL_READER_ERROR_UNKNOWN_TYPE,
	PL_READER_ERROR_SOMETHING_ELSE
} PlReaderError;
#define PL_READER_ERROR pl_reader_error_quark ()
typedef enum  {
	PL_WRITER_ERROR_UNKNOWN_TYPE,
	PL_WRITER_ERROR_NO_DATA,
	PL_WRITER_ERROR_NO_DEST_URI,
	PL_WRITER_ERROR_DEST_REMOTE
} PlWriterError;
#define PL_WRITER_ERROR pl_writer_error_quark ()
typedef enum  {
	PL_INTERNAL_READER_ERROR_UNKNOWN_TYPE,
	PL_INTERNAL_READER_ERROR_INVALID_FILE,
	PL_INTERNAL_READER_ERROR_SOMETHING_ELSE
} PlInternalReaderError;
#define PL_INTERNAL_READER_ERROR pl_internal_reader_error_quark ()
typedef enum  {
	PL_INTERNAL_WRITER_ERROR_UNKNOWN_TYPE,
	PL_INTERNAL_WRITER_ERROR_SOMETHING_ELSE
} PlInternalWriterError;
#define PL_INTERNAL_WRITER_ERROR pl_internal_writer_error_quark ()
typedef enum  {
	PL_LIST_TYPE_UNKNOWN = 0,
	PL_LIST_TYPE_IGNORED,
	PL_LIST_TYPE_M3U,
	PL_LIST_TYPE_PLS,
	PL_LIST_TYPE_ASX,
	PL_LIST_TYPE_XSPF,
	PL_LIST_TYPE_WPL
} PlListType;

typedef enum  {
	PL_RESULT_UNHANDLED = 0,
	PL_RESULT_ERROR,
	PL_RESULT_IGNORED,
	PL_RESULT_SUCCESS,
	PL_RESULT_EMPTY,
	PL_RESULT_DOUBLE_WRITE
} PlResult;

typedef enum  {
	PL_TARGET_TYPE_URI,
	PL_TARGET_TYPE_REL_PATH,
	PL_TARGET_TYPE_ABS_PATH
} PlTargetType;

struct _PlContentType {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PlContentTypePrivate * priv;
};

struct _PlContentTypeClass {
	GTypeClass parent_class;
	void (*finalize) (PlContentType *self);
};

struct _PlParamSpecContentType {
	GParamSpec parent_instance;
};


static gpointer pl_content_type_parent_class = NULL;
extern gboolean pl_debug;
gboolean pl_debug = FALSE;

GQuark pl_reader_error_quark (void);
GQuark pl_writer_error_quark (void);
GQuark pl_internal_reader_error_quark (void);
GQuark pl_internal_writer_error_quark (void);
GType pl_list_type_get_type (void) G_GNUC_CONST;
GType pl_result_get_type (void) G_GNUC_CONST;
GType pl_target_type_get_type (void) G_GNUC_CONST;
gpointer pl_content_type_ref (gpointer instance);
void pl_content_type_unref (gpointer instance);
GParamSpec* pl_param_spec_content_type (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void pl_value_set_content_type (GValue* value, gpointer v_object);
void pl_value_take_content_type (GValue* value, gpointer v_object);
gpointer pl_value_get_content_type (const GValue* value);
GType pl_content_type_get_type (void) G_GNUC_CONST;
enum  {
	PL_CONTENT_TYPE_DUMMY_PROPERTY
};
#define PL_CONTENT_TYPE_ASX "audio/x-ms-asx"
#define PL_CONTENT_TYPE_PLS "audio/x-scpls"
#define PL_CONTENT_TYPE_APPLE_MPEG "application/vnd.apple.mpegurl"
#define PL_CONTENT_TYPE_X_MPEG "audio/x-mpegurl"
#define PL_CONTENT_TYPE_MPEG "audio/mpegurl"
#define PL_CONTENT_TYPE_XSPF "application/xspf+xml"
#define PL_CONTENT_TYPE_WPL "application/vnd.ms-wpl"
PlContentType* pl_content_type_new (void);
PlContentType* pl_content_type_construct (GType object_type);
static void pl_content_type_finalize (PlContentType* obj);
gboolean pl_is_known_playlist_extension (char** ext);
char* pl_get_extension (GFile* f);
static int _vala_strcmp0 (const char * str1, const char * str2);

const char* PL_known_playlist_extensions[5] = {"asx", "pls", "m3u", "wpl", "xspf"};
const char* PL_remote_schemes[2] = {"http", "ftp"};


GQuark pl_reader_error_quark (void) {
	return g_quark_from_static_string ("pl_reader_error-quark");
}


GQuark pl_writer_error_quark (void) {
	return g_quark_from_static_string ("pl_writer_error-quark");
}


GQuark pl_internal_reader_error_quark (void) {
	return g_quark_from_static_string ("pl_internal_reader_error-quark");
}


GQuark pl_internal_writer_error_quark (void) {
	return g_quark_from_static_string ("pl_internal_writer_error-quark");
}


GType pl_list_type_get_type (void) {
	static volatile gsize pl_list_type_type_id__volatile = 0;
	if (g_once_init_enter (&pl_list_type_type_id__volatile)) {
		static const GEnumValue values[] = {{PL_LIST_TYPE_UNKNOWN, "PL_LIST_TYPE_UNKNOWN", "unknown"}, {PL_LIST_TYPE_IGNORED, "PL_LIST_TYPE_IGNORED", "ignored"}, {PL_LIST_TYPE_M3U, "PL_LIST_TYPE_M3U", "m3u"}, {PL_LIST_TYPE_PLS, "PL_LIST_TYPE_PLS", "pls"}, {PL_LIST_TYPE_ASX, "PL_LIST_TYPE_ASX", "asx"}, {PL_LIST_TYPE_XSPF, "PL_LIST_TYPE_XSPF", "xspf"}, {PL_LIST_TYPE_WPL, "PL_LIST_TYPE_WPL", "wpl"}, {0, NULL, NULL}};
		GType pl_list_type_type_id;
		pl_list_type_type_id = g_enum_register_static ("PlListType", values);
		g_once_init_leave (&pl_list_type_type_id__volatile, pl_list_type_type_id);
	}
	return pl_list_type_type_id__volatile;
}


GType pl_result_get_type (void) {
	static volatile gsize pl_result_type_id__volatile = 0;
	if (g_once_init_enter (&pl_result_type_id__volatile)) {
		static const GEnumValue values[] = {{PL_RESULT_UNHANDLED, "PL_RESULT_UNHANDLED", "unhandled"}, {PL_RESULT_ERROR, "PL_RESULT_ERROR", "error"}, {PL_RESULT_IGNORED, "PL_RESULT_IGNORED", "ignored"}, {PL_RESULT_SUCCESS, "PL_RESULT_SUCCESS", "success"}, {PL_RESULT_EMPTY, "PL_RESULT_EMPTY", "empty"}, {PL_RESULT_DOUBLE_WRITE, "PL_RESULT_DOUBLE_WRITE", "double-write"}, {0, NULL, NULL}};
		GType pl_result_type_id;
		pl_result_type_id = g_enum_register_static ("PlResult", values);
		g_once_init_leave (&pl_result_type_id__volatile, pl_result_type_id);
	}
	return pl_result_type_id__volatile;
}


GType pl_target_type_get_type (void) {
	static volatile gsize pl_target_type_type_id__volatile = 0;
	if (g_once_init_enter (&pl_target_type_type_id__volatile)) {
		static const GEnumValue values[] = {{PL_TARGET_TYPE_URI, "PL_TARGET_TYPE_URI", "uri"}, {PL_TARGET_TYPE_REL_PATH, "PL_TARGET_TYPE_REL_PATH", "rel-path"}, {PL_TARGET_TYPE_ABS_PATH, "PL_TARGET_TYPE_ABS_PATH", "abs-path"}, {0, NULL, NULL}};
		GType pl_target_type_type_id;
		pl_target_type_type_id = g_enum_register_static ("PlTargetType", values);
		g_once_init_leave (&pl_target_type_type_id__volatile, pl_target_type_type_id);
	}
	return pl_target_type_type_id__volatile;
}


PlContentType* pl_content_type_construct (GType object_type) {
	PlContentType* self;
	self = (PlContentType*) g_type_create_instance (object_type);
	return self;
}


PlContentType* pl_content_type_new (void) {
	return pl_content_type_construct (PL_TYPE_CONTENT_TYPE);
}


static void pl_value_content_type_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void pl_value_content_type_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		pl_content_type_unref (value->data[0].v_pointer);
	}
}


static void pl_value_content_type_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = pl_content_type_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer pl_value_content_type_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* pl_value_content_type_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		PlContentType* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = pl_content_type_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* pl_value_content_type_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PlContentType** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = pl_content_type_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* pl_param_spec_content_type (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	PlParamSpecContentType* spec;
	g_return_val_if_fail (g_type_is_a (object_type, PL_TYPE_CONTENT_TYPE), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer pl_value_get_content_type (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PL_TYPE_CONTENT_TYPE), NULL);
	return value->data[0].v_pointer;
}


void pl_value_set_content_type (GValue* value, gpointer v_object) {
	PlContentType* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PL_TYPE_CONTENT_TYPE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PL_TYPE_CONTENT_TYPE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		pl_content_type_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		pl_content_type_unref (old);
	}
}


void pl_value_take_content_type (GValue* value, gpointer v_object) {
	PlContentType* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PL_TYPE_CONTENT_TYPE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PL_TYPE_CONTENT_TYPE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		pl_content_type_unref (old);
	}
}


static void pl_content_type_class_init (PlContentTypeClass * klass) {
	pl_content_type_parent_class = g_type_class_peek_parent (klass);
	PL_CONTENT_TYPE_CLASS (klass)->finalize = pl_content_type_finalize;
}


static void pl_content_type_instance_init (PlContentType * self) {
	self->ref_count = 1;
}


static void pl_content_type_finalize (PlContentType* obj) {
	PlContentType * self;
	self = PL_CONTENT_TYPE (obj);
}


GType pl_content_type_get_type (void) {
	static volatile gsize pl_content_type_type_id__volatile = 0;
	if (g_once_init_enter (&pl_content_type_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { pl_value_content_type_init, pl_value_content_type_free_value, pl_value_content_type_copy_value, pl_value_content_type_peek_pointer, "p", pl_value_content_type_collect_value, "p", pl_value_content_type_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PlContentTypeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pl_content_type_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlContentType), 0, (GInstanceInitFunc) pl_content_type_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType pl_content_type_type_id;
		pl_content_type_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PlContentType", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&pl_content_type_type_id__volatile, pl_content_type_type_id);
	}
	return pl_content_type_type_id__volatile;
}


gpointer pl_content_type_ref (gpointer instance) {
	PlContentType* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void pl_content_type_unref (gpointer instance) {
	PlContentType* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		PL_CONTENT_TYPE_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


gboolean pl_is_known_playlist_extension (char** ext) {
	gboolean result = FALSE;
	g_return_val_if_fail (ext != NULL, FALSE);
	{
		const char** s_collection;
		int s_collection_length1;
		int s_it;
		s_collection = PL_known_playlist_extensions;
		s_collection_length1 = G_N_ELEMENTS (PL_known_playlist_extensions);
		for (s_it = 0; s_it < G_N_ELEMENTS (PL_known_playlist_extensions); s_it = s_it + 1) {
			char* s;
			s = g_strdup (s_collection[s_it]);
			{
				if (_vala_strcmp0 (*ext, s) == 0) {
					result = TRUE;
					_g_free0 (s);
					return result;
				}
				_g_free0 (s);
			}
		}
	}
	result = FALSE;
	return result;
}


char* pl_get_extension (GFile* f) {
	char* result = NULL;
	char* uri;
	char* ext;
	if (f == NULL) {
		result = NULL;
		return result;
	}
	uri = g_file_get_uri (f);
	g_assert (uri != NULL);
	ext = g_strdup (g_strrstr (uri, "."));
	result = ext;
	_g_free0 (uri);
	return result;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




