/* pl-item.c generated by valac 0.10.0, the Vala compiler
 * generated from pl-item.vala, do not modify */

/* pl-item.vala
 *
 * Copyright (C) 2010  Jörn Magens
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jörn Magens <shuerhaaken@googlemail.com>
 */
/* an instance of this Item object represents one entry in the list. An entry contains one or more data fields, at least the uri to the target*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>


#define PL_TYPE_ITEM (pl_item_get_type ())
#define PL_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PL_TYPE_ITEM, PlItem))
#define PL_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PL_TYPE_ITEM, PlItemClass))
#define PL_IS_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PL_TYPE_ITEM))
#define PL_IS_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PL_TYPE_ITEM))
#define PL_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PL_TYPE_ITEM, PlItemClass))

typedef struct _PlItem PlItem;
typedef struct _PlItemClass PlItemClass;
typedef struct _PlItemPrivate PlItemPrivate;

#define PL_ITEM_TYPE_FIELD (pl_item_field_get_type ())

#define PL_TYPE_TARGET_TYPE (pl_target_type_get_type ())
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _PlParamSpecItem PlParamSpecItem;

struct _PlItem {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PlItemPrivate * priv;
};

struct _PlItemClass {
	GTypeClass parent_class;
	void (*finalize) (PlItem *self);
};

typedef enum  {
	PL_ITEM_FIELD_URI = 0,
	PL_ITEM_FIELD_TITLE,
	PL_ITEM_FIELD_AUTHOR,
	PL_ITEM_FIELD_GENRE,
	PL_ITEM_FIELD_ALBUM,
	PL_ITEM_FIELD_COPYRIGHT,
	PL_ITEM_FIELD_DURATION,
	PL_ITEM_FIELD_PARAM_NAME,
	PL_ITEM_FIELD_PARAM_VALUE,
	PL_ITEM_FIELD_IS_REMOTE,
	PL_ITEM_FIELD_IS_PLAYLIST
} PlItemField;

typedef enum  {
	PL_TARGET_TYPE_URI,
	PL_TARGET_TYPE_REL_PATH,
	PL_TARGET_TYPE_ABS_PATH
} PlTargetType;

struct _PlItemPrivate {
	GHashTable* htable;
	PlTargetType _target_type;
	char* _base_path;
};

struct _PlParamSpecItem {
	GParamSpec parent_instance;
};


static gpointer pl_item_parent_class = NULL;

gpointer pl_item_ref (gpointer instance);
void pl_item_unref (gpointer instance);
GParamSpec* pl_param_spec_item (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void pl_value_set_item (GValue* value, gpointer v_object);
void pl_value_take_item (GValue* value, gpointer v_object);
gpointer pl_value_get_item (const GValue* value);
GType pl_item_get_type (void) G_GNUC_CONST;
GType pl_item_field_get_type (void) G_GNUC_CONST;
GType pl_target_type_get_type (void) G_GNUC_CONST;
#define PL_ITEM_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), PL_TYPE_ITEM, PlItemPrivate))
enum  {
	PL_ITEM_DUMMY_PROPERTY
};
PlItem* pl_item_new (void);
PlItem* pl_item_construct (GType object_type);
void pl_item_add_field (PlItem* self, PlItemField field, const char* val);
PlItemField* pl_item_get_contained_fields (PlItem* self, int* result_length1);
static void _vala_array_add1 (PlItemField** array, int* length, int* size, PlItemField value);
char* pl_item_get_field (PlItem* self, PlItemField field);
char* pl_item_get_uri (PlItem* self);
char* pl_item_get_rel_path (PlItem* self);
const char* pl_item_get_base_path (PlItem* self);
char* pl_item_get_abs_path (PlItem* self);
static gboolean _vala_string_array_contains (const char** stack, int stack_length, const char* needle);
char* pl_item_get_title (PlItem* self);
char* pl_item_get_author (PlItem* self);
char* pl_item_get_genre (PlItem* self);
char* pl_item_get_album (PlItem* self);
char* pl_item_get_copyright (PlItem* self);
char* pl_item_get_duration_string (PlItem* self);
char* pl_item_get_param_name (PlItem* self);
char* pl_item_get_param_value (PlItem* self);
glong pl_item_get_duration (PlItem* self);
glong pl_get_duration_from_string (char** duration_string);
gboolean pl_item_is_remote (PlItem* self);
gboolean pl_item_is_playlist (PlItem* self);
PlTargetType pl_item_get_target_type (PlItem* self);
void pl_item_set_target_type (PlItem* self, PlTargetType value);
void pl_item_set_base_path (PlItem* self, const char* value);
static void pl_item_finalize (PlItem* obj);
static int _vala_strcmp0 (const char * str1, const char * str2);

extern const char* PL_remote_schemes[2];


GType pl_item_field_get_type (void) {
	static volatile gsize pl_item_field_type_id__volatile = 0;
	if (g_once_init_enter (&pl_item_field_type_id__volatile)) {
		static const GEnumValue values[] = {{PL_ITEM_FIELD_URI, "PL_ITEM_FIELD_URI", "uri"}, {PL_ITEM_FIELD_TITLE, "PL_ITEM_FIELD_TITLE", "title"}, {PL_ITEM_FIELD_AUTHOR, "PL_ITEM_FIELD_AUTHOR", "author"}, {PL_ITEM_FIELD_GENRE, "PL_ITEM_FIELD_GENRE", "genre"}, {PL_ITEM_FIELD_ALBUM, "PL_ITEM_FIELD_ALBUM", "album"}, {PL_ITEM_FIELD_COPYRIGHT, "PL_ITEM_FIELD_COPYRIGHT", "copyright"}, {PL_ITEM_FIELD_DURATION, "PL_ITEM_FIELD_DURATION", "duration"}, {PL_ITEM_FIELD_PARAM_NAME, "PL_ITEM_FIELD_PARAM_NAME", "param-name"}, {PL_ITEM_FIELD_PARAM_VALUE, "PL_ITEM_FIELD_PARAM_VALUE", "param-value"}, {PL_ITEM_FIELD_IS_REMOTE, "PL_ITEM_FIELD_IS_REMOTE", "is-remote"}, {PL_ITEM_FIELD_IS_PLAYLIST, "PL_ITEM_FIELD_IS_PLAYLIST", "is-playlist"}, {0, NULL, NULL}};
		GType pl_item_field_type_id;
		pl_item_field_type_id = g_enum_register_static ("PlItemField", values);
		g_once_init_leave (&pl_item_field_type_id__volatile, pl_item_field_type_id);
	}
	return pl_item_field_type_id__volatile;
}


PlItem* pl_item_construct (GType object_type) {
	PlItem* self;
	GHashTable* _tmp0_;
	self = (PlItem*) g_type_create_instance (object_type);
	self->priv->htable = (_tmp0_ = g_hash_table_new_full (g_direct_hash, g_direct_equal, NULL, g_free), _g_hash_table_unref0 (self->priv->htable), _tmp0_);
	return self;
}


PlItem* pl_item_new (void) {
	return pl_item_construct (PL_TYPE_ITEM);
}


void pl_item_add_field (PlItem* self, PlItemField field, const char* val) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (val != NULL);
	g_hash_table_insert (self->priv->htable, GINT_TO_POINTER (field), g_strdup (val));
}


static void _vala_array_add1 (PlItemField** array, int* length, int* size, PlItemField value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (PlItemField, *array, *size);
	}
	(*array)[(*length)++] = value;
}


PlItemField* pl_item_get_contained_fields (PlItem* self, int* result_length1) {
	PlItemField* result = NULL;
	gint retval_length1;
	gint _retval_size_;
	PlItemField* _tmp1_;
	PlItemField* _tmp0_ = NULL;
	PlItemField* retval;
	GList* list;
	PlItemField* _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	retval = (_tmp1_ = (_tmp0_ = g_new0 (PlItemField, 0), _tmp0_), retval_length1 = 0, _retval_size_ = retval_length1, _tmp1_);
	list = g_hash_table_get_keys (self->priv->htable);
	if (list == NULL) {
		PlItemField* _tmp2_;
		result = (_tmp2_ = retval, *result_length1 = retval_length1, _tmp2_);
		_g_list_free0 (list);
		return result;
	}
	{
		GList* f_collection;
		GList* f_it;
		f_collection = list;
		for (f_it = f_collection; f_it != NULL; f_it = f_it->next) {
			PlItemField f;
			f = GPOINTER_TO_INT (f_it->data);
			{
				_vala_array_add1 (&retval, &retval_length1, &_retval_size_, f);
			}
		}
	}
	result = (_tmp3_ = retval, *result_length1 = retval_length1, _tmp3_);
	_g_list_free0 (list);
	return result;
	_g_list_free0 (list);
	retval = (g_free (retval), NULL);
}


char* pl_item_get_field (PlItem* self, PlItemField field) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = g_strdup ((const char*) g_hash_table_lookup (self->priv->htable, GINT_TO_POINTER (field)));
	return result;
}


char* pl_item_get_uri (PlItem* self) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = g_strdup ((const char*) g_hash_table_lookup (self->priv->htable, GINT_TO_POINTER (PL_ITEM_FIELD_URI)));
	return result;
}


char* pl_item_get_rel_path (PlItem* self) {
	char* result = NULL;
	char* s;
	GFile* f;
	GFile* bp;
	g_return_val_if_fail (self != NULL, NULL);
	s = g_strdup ((const char*) g_hash_table_lookup (self->priv->htable, GINT_TO_POINTER (PL_ITEM_FIELD_URI)));
	if (s == NULL) {
		result = NULL;
		_g_free0 (s);
		return result;
	}
	f = g_file_new_for_uri (s);
	if (self->priv->_base_path == NULL) {
		result = NULL;
		_g_object_unref0 (f);
		_g_free0 (s);
		return result;
	}
	bp = g_file_new_for_path (self->priv->_base_path);
	if (bp == NULL) {
		result = NULL;
		_g_object_unref0 (bp);
		_g_object_unref0 (f);
		_g_free0 (s);
		return result;
	}
	result = g_file_get_relative_path (bp, f);
	_g_object_unref0 (bp);
	_g_object_unref0 (f);
	_g_free0 (s);
	return result;
}


static gboolean _vala_string_array_contains (const char** stack, int stack_length, const char* needle) {
	int i;
	for (i = 0; i < stack_length; i++) {
		if (_vala_strcmp0 (stack[i], needle) == 0) {
			return TRUE;
		}
	}
	return FALSE;
}


char* pl_item_get_abs_path (PlItem* self) {
	char* result = NULL;
	char* s;
	GFile* f;
	char* _tmp0_;
	gboolean _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	s = g_strdup ((const char*) g_hash_table_lookup (self->priv->htable, GINT_TO_POINTER (PL_ITEM_FIELD_URI)));
	if (s == NULL) {
		result = NULL;
		_g_free0 (s);
		return result;
	}
	f = g_file_new_for_uri (s);
	if ((_tmp1_ = _vala_string_array_contains (PL_remote_schemes, G_N_ELEMENTS (PL_remote_schemes), _tmp0_ = g_file_get_uri_scheme (f)), _g_free0 (_tmp0_), _tmp1_)) {
		result = NULL;
		_g_object_unref0 (f);
		_g_free0 (s);
		return result;
	}
	result = g_file_get_path (f);
	_g_object_unref0 (f);
	_g_free0 (s);
	return result;
}


char* pl_item_get_title (PlItem* self) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = g_strdup ((const char*) g_hash_table_lookup (self->priv->htable, GINT_TO_POINTER (PL_ITEM_FIELD_TITLE)));
	return result;
}


char* pl_item_get_author (PlItem* self) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = g_strdup ((const char*) g_hash_table_lookup (self->priv->htable, GINT_TO_POINTER (PL_ITEM_FIELD_AUTHOR)));
	return result;
}


char* pl_item_get_genre (PlItem* self) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = g_strdup ((const char*) g_hash_table_lookup (self->priv->htable, GINT_TO_POINTER (PL_ITEM_FIELD_GENRE)));
	return result;
}


char* pl_item_get_album (PlItem* self) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = g_strdup ((const char*) g_hash_table_lookup (self->priv->htable, GINT_TO_POINTER (PL_ITEM_FIELD_ALBUM)));
	return result;
}


char* pl_item_get_copyright (PlItem* self) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = g_strdup ((const char*) g_hash_table_lookup (self->priv->htable, GINT_TO_POINTER (PL_ITEM_FIELD_COPYRIGHT)));
	return result;
}


char* pl_item_get_duration_string (PlItem* self) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = g_strdup ((const char*) g_hash_table_lookup (self->priv->htable, GINT_TO_POINTER (PL_ITEM_FIELD_DURATION)));
	return result;
}


char* pl_item_get_param_name (PlItem* self) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = g_strdup ((const char*) g_hash_table_lookup (self->priv->htable, GINT_TO_POINTER (PL_ITEM_FIELD_PARAM_NAME)));
	return result;
}


char* pl_item_get_param_value (PlItem* self) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = g_strdup ((const char*) g_hash_table_lookup (self->priv->htable, GINT_TO_POINTER (PL_ITEM_FIELD_PARAM_VALUE)));
	return result;
}


glong pl_item_get_duration (PlItem* self) {
	glong result = 0L;
	char* s;
	g_return_val_if_fail (self != NULL, 0L);
	s = g_strdup ((const char*) g_hash_table_lookup (self->priv->htable, GINT_TO_POINTER (PL_ITEM_FIELD_DURATION)));
	if (s == NULL) {
		result = (glong) (-1);
		_g_free0 (s);
		return result;
	}
	result = pl_get_duration_from_string (&s);
	_g_free0 (s);
	return result;
}


gboolean pl_item_is_remote (PlItem* self) {
	gboolean result = FALSE;
	char* s;
	g_return_val_if_fail (self != NULL, FALSE);
	s = g_strdup ((const char*) g_hash_table_lookup (self->priv->htable, GINT_TO_POINTER (PL_ITEM_FIELD_IS_REMOTE)));
	if (_vala_strcmp0 (s, "1") == 0) {
		result = TRUE;
		_g_free0 (s);
		return result;
	}
	result = FALSE;
	_g_free0 (s);
	return result;
}


gboolean pl_item_is_playlist (PlItem* self) {
	gboolean result = FALSE;
	char* s;
	g_return_val_if_fail (self != NULL, FALSE);
	s = g_strdup ((const char*) g_hash_table_lookup (self->priv->htable, GINT_TO_POINTER (PL_ITEM_FIELD_IS_PLAYLIST)));
	if (_vala_strcmp0 (s, "1") == 0) {
		result = TRUE;
		_g_free0 (s);
		return result;
	}
	result = FALSE;
	_g_free0 (s);
	return result;
}


PlTargetType pl_item_get_target_type (PlItem* self) {
	PlTargetType result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_target_type;
	return result;
}


void pl_item_set_target_type (PlItem* self, PlTargetType value) {
	g_return_if_fail (self != NULL);
	self->priv->_target_type = value;
}


const char* pl_item_get_base_path (PlItem* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_base_path;
	return result;
}


void pl_item_set_base_path (PlItem* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_base_path = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_base_path), _tmp0_);
}


static void pl_value_item_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void pl_value_item_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		pl_item_unref (value->data[0].v_pointer);
	}
}


static void pl_value_item_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = pl_item_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer pl_value_item_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* pl_value_item_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		PlItem* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = pl_item_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* pl_value_item_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PlItem** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = pl_item_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* pl_param_spec_item (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	PlParamSpecItem* spec;
	g_return_val_if_fail (g_type_is_a (object_type, PL_TYPE_ITEM), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer pl_value_get_item (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PL_TYPE_ITEM), NULL);
	return value->data[0].v_pointer;
}


void pl_value_set_item (GValue* value, gpointer v_object) {
	PlItem* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PL_TYPE_ITEM));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PL_TYPE_ITEM));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		pl_item_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		pl_item_unref (old);
	}
}


void pl_value_take_item (GValue* value, gpointer v_object) {
	PlItem* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PL_TYPE_ITEM));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PL_TYPE_ITEM));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		pl_item_unref (old);
	}
}


static void pl_item_class_init (PlItemClass * klass) {
	pl_item_parent_class = g_type_class_peek_parent (klass);
	PL_ITEM_CLASS (klass)->finalize = pl_item_finalize;
	g_type_class_add_private (klass, sizeof (PlItemPrivate));
}


static void pl_item_instance_init (PlItem * self) {
	self->priv = PL_ITEM_GET_PRIVATE (self);
	self->priv->htable = NULL;
	self->priv->_target_type = PL_TARGET_TYPE_URI;
	self->priv->_base_path = NULL;
	self->ref_count = 1;
}


static void pl_item_finalize (PlItem* obj) {
	PlItem * self;
	self = PL_ITEM (obj);
	{
		GHashTable* _tmp0_;
		self->priv->htable = (_tmp0_ = NULL, _g_hash_table_unref0 (self->priv->htable), _tmp0_);
	}
	_g_hash_table_unref0 (self->priv->htable);
	_g_free0 (self->priv->_base_path);
}


GType pl_item_get_type (void) {
	static volatile gsize pl_item_type_id__volatile = 0;
	if (g_once_init_enter (&pl_item_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { pl_value_item_init, pl_value_item_free_value, pl_value_item_copy_value, pl_value_item_peek_pointer, "p", pl_value_item_collect_value, "p", pl_value_item_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PlItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pl_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlItem), 0, (GInstanceInitFunc) pl_item_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType pl_item_type_id;
		pl_item_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PlItem", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&pl_item_type_id__volatile, pl_item_type_id);
	}
	return pl_item_type_id__volatile;
}


gpointer pl_item_ref (gpointer instance) {
	PlItem* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void pl_item_unref (gpointer instance) {
	PlItem* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		PL_ITEM_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




